Attribute VB_Name = "CHAT_Functions"
Option Explicit
'--------------------------------------------------------------
Public Sub InitServerList(ServerList As ComboBox)
'   
'--------------------------------------------------------------
    'On Error Resume Next
    Dim listData As String
    Dim i As Integer
    Dim sInt As Integer
'--------------------------------------------------------------
    listData = GetSetting(App.EXEName, "Options", "Servers")
    If Trim(listData) = "" Then Exit Sub
    sInt = 1
    For i = 1 To Len(listData)
        If Mid(listData, i, 1) = vbCr Then
        ServerList.AddItem Mid(listData, sInt, i - sInt)
        End If
    Next i
'--------------------------------------------------------------
End Sub
'--------------------------------------------------------------
Public Sub DebugSocket(TCPSocket As Winsock)
' ,    Winsock control'
'--------------------------------------------------------------
    Debug.Print "TCPSocket.RemoteHost", TCPSocket.RemoteHost
    Debug.Print "TCPSocket.RemoteHostIP", TCPSocket.RemoteHostIP
    Debug.Print "TCPSocket.RemotePort", TCPSocket.RemotePort
    Debug.Print "TCPSocket.LocalHostName", TCPSocket.LocalHostName
    Debug.Print "TCPSocket.LocalIP", TCPSocket.LocalIP
    Debug.Print "TCPSocket.LocalPort", TCPSocket.LocalPort
    Debug.Print "TCPSocket.State", TCPSocket.State
    Debug.Print "====================================================="
'--------------------------------------------------------------
End Sub
'--------------------------------------------------------------
Public Sub ResPlaySound(ResourceId As Long)
'    
'------------------------------------------------------------------
    Dim sndBuff As String
'------------------------------------------------------------------
    sndBuff = StrConv(LoadResData(ResourceId, "WAVE"), vbUnicode)
    Call sndPlaySound(sndBuff, SND_SYNC Or SND_MEMORY)
'------------------------------------------------------------------
End Sub
'------------------------------------------------------------------
Public Sub AddConnectionToList(Socket As Winsock, ConnList As ListBox)
'      
'--------------------------------------------------------------
    Dim MemberID As String
'--------------------------------------------------------------
    MemberID = Socket.RemoteHostIP & "  [" & _
               Format(Socket.RemotePort, "0") & "] - [" & _
               Format(Socket.LocalPort, "0") & "]"

    ConnList.AddItem MemberID
    ConnList.ItemData(ConnList.NewIndex) = Socket.Index
'--------------------------------------------------------------
End Sub
'--------------------------------------------------------------
Public Sub RemoveConnectionFromList(Socket As Winsock, ConnList As ListBox)
'      
'--------------------------------------------------------------
    Dim Conn As Long
    Dim MemberID As String
'--------------------------------------------------------------
    MemberID = Socket.RemoteHostIP & "  [" & _
               Format(Socket.RemotePort, "0") & "] - [" & _
               Format(Socket.LocalPort, "0") & "]"
    
    For Conn = 0 To ConnList.ListCount - 1
        If (ConnList.List(Conn) = MemberID) Then
            ConnList.RemoveItem Conn
        End If
    Next
'--------------------------------------------------------------
End Sub
'--------------------------------------------------------------
Public Sub GetIdxFromMemberID(Sockets As Variant, MemberID As String, Index As Long)
'--------------------------------------------------------------
    Dim Idx As Long
    Dim LocPortID As Long
    Dim RemPortID As Long
    Dim RemoteIP As String
    Dim sStart As Long
    Dim sEnd As Long
    Dim Socket As Winsock
'--------------------------------------------------------------
    sStart = 1
    sEnd = InStr(1, MemberID, " ") - 1
    If (sEnd > 1) Then
        RemoteIP = Mid(MemberID, sStart, sEnd)
        sStart = InStr(sEnd, MemberID, "[") + 1
        If (sStart > 1) Then
            sEnd = InStr(sStart, MemberID, "]") - 1
            If (sEnd > 2) Then
                RemPortID = Val(Mid(MemberID, sStart, sEnd))
                sStart = InStr(sEnd, MemberID, "[") + 1
                If (sStart > 1) Then
                    sEnd = InStr(sStart, MemberID, "]") - 1
                    If (sEnd > 2) Then
                        LocPortID = Val(Mid(MemberID, sStart, sEnd))
                        For Each Socket In Sockets
                            If ((Socket.RemoteHostIP = RemoteIP) And _
                                (Socket.RemotePort = RemPortID) And _
                                (Socket.LocalPort = LocPortID) And _
                                (Socket.Index > 0)) Then
                                Index = Socket.Index
                                Exit Sub
                            End If
                        Next
                    End If
                End If
            End If
        End If
    End If
'--------------------------------------------------------------
End Sub
'--------------------------------------------------------------
