Attribute VB_Name = "TCP_Functions"
Option Explicit
'------------------------------------------------------------
Public Function InstanceTCP(TCPArray As Variant) As Long
'   Winsock control
'------------------------------------------------------------
    Dim Ind As Long
'------------------------------------------------------------
    InstanceTCP = -1
    On Error GoTo InitControl
    
    For Ind = MINTCP To MAXTCP                      '   
        If (TCPArray(Ind).Name = "") Then
'   ,   Winsock'     
        End If
    Next
'------------------------------------------------------------
InitControl:
'------------------------------------------------------------
    On Error GoTo ErrorHandler
            
    If ((Ind >= MINTCP) And (Ind <= MAXTCP)) Then
        Load TCPArray(Ind)
        InstanceTCP = Ind
    End If
    
    Exit Function
'------------------------------------------------------------
ErrorHandler:
'------------------------------------------------------------
    Debug.Print Err.Number, Err.Description
    Resume Next
'------------------------------------------------------------
End Function
'------------------------------------------------------------
Public Function Connect(Socket As Winsock, RemHost As String, RemPort As Long) As Boolean
'   
'------------------------------------------------------------------
    Connect = False
    Call CloseListen(Socket)
    Socket.LocalPort = 0
    Call Socket.Connect(RemHost, RemPort)
    
    Do While ((Socket.State = sckConnecting) Or _
              (Socket.State = sckConnectionPending) Or _
              (Socket.State = sckResolvingHost) Or _
              (Socket.State = sckHostResolved) Or _
              (Socket.State = sckOpen))
        DoEvents
    Loop

    Connect = (Socket.State = sckConnected)     '   ?
'------------------------------------------------------------------
End Function
'------------------------------------------------------------------
Public Function Listen(Socket As Winsock) As Long
'  
'------------------------------------------------------------------
    If (Socket.State <> sckListening) Then
        If (Socket.LocalPort = 0) Then
            Socket.LocalPort = VOICEPORT
        End If
        Call Socket.Listen
    End If
'------------------------------------------------------------------
End Function
'------------------------------------------------------------------
Public Function CloseListen(Socket As Winsock) As Long
'     
'------------------------------------------------------------------
    If (Socket.State = sckListening) Then
        Socket.Close
    End If
'------------------------------------------------------------------
End Function
'------------------------------------------------------------------
Public Sub Disconnect(Socket As Winsock)
'  
'------------------------------------------------------------------
    If (Socket.State <> sckClosed) Then
        Socket.Close
    End If
'------------------------------------------------------------------
End Sub
'------------------------------------------------------------------
